



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅谈java垃圾回收机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅谈java垃圾回收机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 08:10:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　今天看thinking in java，里面很详细的谈到java垃圾回收器机制，看完后让我对这神秘的区域有一定的了解，特写一些小总结记录下来。</p>
<p>　　分两点来说。</p>
<p>　　第一点：Object.finalize();方法。finalize()方法是Object类的意味着所有类都可以使用、重写该方法。当对象调用finalize方法后，相当于告诉垃圾回收器：&ldquo;我是垃圾，在下次垃圾回收的时候可以把我回收&rdquo;，然后垃圾回收器在下次回收垃圾的时候就把这个对象给回收了，但是在程序运行周期中，垃圾回收器不一定会执行，它一般在虚拟机内存不够的时候才会执行，为什么是这样呢？因为垃圾回收器的执行也消耗资源、性能，而且在程序结束的时候，虚拟机的内存会自动释放归还给内存。当然你也可以显示地调用System.gc();来告诉系统立刻、马上进行垃圾回收，但是不建议这么做，虚拟机总是在最优的时刻调用垃圾回收。很多经验丰富的开发者同时建议：如果不是必须，最好不要使用finalize()。</p>
<p>　　第二点：垃圾回收。垃圾回收这个动作实际上做了两件事，1、回收垃圾，释放内存；2、重新排列堆中内容，让内存的分配更高效。</p>
<p>　　在程序启动后，java虚拟机在不断地监视着内存情况，如果发现垃圾比较多，对象在堆中排布比较零散，启动第一种模式：停止-复制（stop and copy）。先把&ldquo;活&rdquo;的对象找出来，怎样找呢？垃圾回收器检索整个堆，因为引用可能不断关联着引用，所以将堆中的引用整理出一个&ldquo;脉络图&rdquo;，没有被引用的就是&ldquo;死&rdquo;的对象，接着，程序短时间停止，把&ldquo;活&rdquo;的对象从堆A复制到堆B中，一个挨一个排列整齐，现在堆A只剩下&ldquo;死&rdquo;的对象了，也就是垃圾，回头把堆A全部清理，这样就完成一次垃圾清理了。</p>
<p>　　假设有9个碎片化严重的对象，排布前和排布后对比：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/796585/201607/796585-20160726165248059-266809384.png" /></p>
<p>　　有人可能想到，如果垃圾比较少，对象比较稳定的情况，那么要把所有&ldquo;活&rdquo;的对象迁移到另一个堆里，不是很耗费性能吗？就好比一座稳定的大山需要搬迁，工程浩大。对于这种情况，启动第二种模式：标记-清除（mark and clear），同样如上方法整理出&ldquo;脉络图&rdquo;，把&ldquo;死&rdquo;的对象标记起来，程序短时间暂停，然后垃圾回收器把标记的对象给回收。因为垃圾较少，不会造成内存碎片化太严重，所以这个模式不会对堆中对象重新排布。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqljgwx9.html">Ambari组件黄色预警</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gr4yeq.html">android之数据存储之SQLite</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1d5xq.html">最大联通子数组之和（dfs，记忆化搜索，状态压缩）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pdlj9.html">用rem来做响应式开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrm649.html">morris&period;js  简单学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o0o149.html">git同一文件由于文件名大小写不同导致不能合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1knkd9.html">SQL Server 2008 表变量参数&lpar;表值参数&rpar;用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4y3mq.html">JSONP实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15rwx9.html">【转】从零开始编写自己的C&num;框架（7）&mdash;&mdash;需求分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mlkjeq.html">Windows 错误代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ve5ej8.html">理解C&num;系列 &sol; 核心C&num; &sol; 变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvroljq.html">spring autoWire注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd6n42q.html">gulp 不是内部或者外部命令  或者 webpack 不是内部或者外部命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1d0m69.html">感动前行&mdash;&mdash;给医学媳妇写的演讲稿&lpar;非IT类）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7jlx9.html">CF192div2-330B - Road Construction</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jw1kv8.html">【MongoDB】The description of index&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl4069.html">Jquery轻量级幻灯插件-OWL Carousel--支持触屏的移动浏览器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge3o6e8.html">Sichuan State Programming Contest 2012 C。Counting Pair</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o57xq.html">shared&lowbar;lock and unique&lowbar;lock</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10jy49.html">最近学习的 Node&period;js 基础：安装、环境配置、forever</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oj15x1q.html">POJ 1201 &amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi; HDU 1384 Intervals&lpar;差动制动系统）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mry2j8.html">Fedora20-Xfce音频视频解码器及解决无声音问题&lbrack;已解决&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj1y55q.html">Spring IOC之基于注解的容器配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpj2l59.html">Canvas入门（3）&colon;图像处理和渲染文本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zj7g39.html">让你的ubuntu串口程序可以直接读写串口</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdw7g49.html">html5 图片上传版本1&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpjk4j9.html">&period;net的页面在大并发下出现503错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gejxge8.html">个推A&sol;B测试评测</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1ylvmq.html">ModelBinder&mdash;&mdash;ASP&period;NET MVC Model绑定的核心</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zj5ve9.html">【IOS开发】搜索和排序（好友列表，通讯录的实现，searchbar）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
